import { injectable } from 'inversify';
import { SloggerProxyDefault } from "../browser/slogger-proxy";
import * as grpc from '@grpc/grpc-js';

import { SLoggerServiceClient } from "../api/slogger_service_grpc_pb";

@injectable()
export class SloggerAPIProxy extends SloggerProxyDefault {
    
    readonly client: SLoggerServiceClient;

    constructor () {
        super();
        this.client = new SLoggerServiceClient("localhost:50051", grpc.credentials.createInsecure());
    }

    public importFile(proto: any): Promise<unknown> {

        let self = this;

        return new Promise( function (resolve, reject) {

            self.client.importFile(
                proto, 
                (error: grpc.ServiceError, response: any) => {
                    if(error) {
                        reject(new Error(error.message));
                    }
                    else {
                        resolve(response);
                    }
                });

            reject("No implementation for importFile");
        });        
    }


}